<?php

namespace App\Http\Controllers\admin;


use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Mail;
use Validator;
use Illuminate\Support\Facades\Auth;

use DB;
use App\Models\AdminUser;
use App\Models\User;
use App\Models\Role;
class AdminUserController extends AdminBaseController
{

    public function __construct()
    {
        parent::__construct(); 

       $this->model=new AdminUser;
       $this->view="user";
   
    }
    /**
     * Create a new controller instance.
     *
     * @return void
     */

    public function index(Request $r)
    {
        $input = $r->all();
       
        $pageLimit=isset($input['rows']) ? $input['rows'] : 25; 
        $pageNumber=isset($input['page']) ? $input['page'] : 1; 
        $offset=$pageNumber*$pageLimit-$pageLimit;   

        $this->data['roles']=Role::where('status','1')->get();

        $query=$this->model::join('users','users.id','admin_users.user_id')
                                    ->leftJoin('roles','roles.id','users.role_id')
                                    ->select('admin_users.*','users.email','users.role_id','roles.name');
        if(isset($input['first_name'])){            
            $query=$query->where('admin_users.first_name', 'LIKE', "%{$input['first_name']}%");
        }
        if(isset($input['email'])){            
            $query=$query->where('users.email', 'LIKE', "%{$input['email']}%");
        }
        if(isset($input['role_id'])){
            $query=$query->where('users.role_id', $input['role_id']);
        }

        $this->data['gridData']=$query->paginate($pageLimit); 
        return view('admin.'.$this->view.'.index',$this->data );

    
    }
    

    public function form(Request $r)
    {   
        $input = $r->all();
        $this->data['content']='';
        if(isset($input['id']) && $input['id']>0){
            $this->data['content']=$this->model::leftjoin('users','users.id','admin_users.user_id')
                                    ->leftJoin('roles','roles.id','users.role_id')
                                    ->select('admin_users.*','users.email','users.role_id')
                                    ->where('admin_users.id',$input['id'])->first();
        }
        
        $this->data['roles']=Role::where('status','1')->get();
        return view('admin.'.$this->view.'.form',$this->data);
    
    }

    public function save(Request $r)
    {   
          
        $input = $r->all();
                
        if(isset($input['id']) && $input['id']>0){
            $adminUser = $this->model->find($input['id']);        
            $adminUser->update($input);
        }
        else{
            $adminUser = $this->model->create($input);
        }

        if(isset($adminUser->user_id)){
            $userData=User::find($adminUser->user_id);
            $userData->email=$input['email'];
            if(isset($input['password'])){
                $userData->password=bcrypt($input['password']);
            }  
            $userData->role_id=$input['role_id'];               
            $userData->save();
        }
        else{
            $userData=User::create([
                'master_id'=>$adminUser->id,
                'email'=>$input['email'],
                'password'=>isset($input['password']) ? bcrypt($input['password']) : '',
                'role_id'=>$input['role_id'],                              
                'section'=>'admin_user'
            ]);

            $adminUser->user_id=$userData->id;
            $adminUser->save();
        }    

        return redirect()->route('admin.'.$this->view);
    
    }

    public function status(Request $request ,$id)
    {
        $menu = $this->model->find($id);
        $menu->status=$menu->status=='1' ? '0' : '1';
        $menu->save();        
        //$page = $request->input('page');
        return redirect()->route('admin.'.$this->view,['identifier'=>$request->input('identifier')]);
    }

    public function priority(Request $request){
        $input = $request->all();
        $menu = $this->model->find($input['id']);        
        $menu->update(array('priority'=>$input['priority']));

        return response()->json([
            'success'=>1,
            'text'=>'Successfully updated the priority'
         ], 200);
    }

    public function delete(Request $request)
    {
        $input = $request->all();
        if(isset($input['id']) && count($input['id'])){
            $this->model->whereIn('id', $input['id'])->update(['isDeleted'=>'1']); 
        }
                
        return redirect()->route('admin.'.$this->data['section'],['identifier'=>$request->input('identifier')]);        
    }



    public function changePassword(Request $r)
    {   
       
        $this->data['position']='';
        $this->data['pages']='';
        //$this->data['centers']=Center::get();
        return view('admin.changepassword',$this->data);

    }
    public function changePasswordsave(Request $r)
    {   
        $input = $r->all();
        
        $user = auth()->guard('admin')->user(); 
       
       
        if(isset($user['id']) && isset($input['oldpassword'])){
           
            $oldpassword=bcrypt($input['oldpassword']);
            //echo $oldpassword;exit;
            $newpassword=bcrypt($input['newpassword']);
            
            $user=$this->model->where('id',$user['id'])
                                               ->where('password',$oldpassword)
                                                 ->first();
            if(isset($user)){                             
                $data['password']=$newpassword;
                $changepassword=$user->update($data);
            
                $this->data['message']="Successfully Changed";
            }
            else{
                 $this->data['message']="Invalid Password";
            }
        }
        
       
        return  redirect()->back()->withErrors(['msg' =>  $this->data['message']]);
        //return redirect()->route('admin.changepassword');
    }

   

	
}
