<?php

namespace App\Http\Controllers\admin;

use PDF;
use SESSION;

use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Mail;
use Validator;
use Illuminate\Support\Facades\Auth;
use Maatwebsite\Excel\Facades\Excel;

use App\Exports\BookingExport;

use App\Models\Booking;
use App\Models\AdminMenu;



class BookingController extends AdminBaseController
{

    public function __construct()
    {
        parent::__construct();    
        
        $this->model=new Booking;
        $this->data['section']="booking";  
        $this->data['view']="booking";        
        
    }

    public function index(Request $request)
    {   
        $input=$request->all();

        $menu=AdminMenu::where('identifier',$request->input('identifier'))->first();        
        $this->data['pageTitle']=$menu['title'];
        $this->data['cFields']=json_decode($menu['custom_fields'],1);
        unset($menu);
        $this->data['cFields']=$this->data['cFields']['grid'];        
        if(isset($this->data['cFields']['top_tools']))
            $this->data['top_tools']=$this->data['cFields']['top_tools']; 

        
        $pageLimit=isset($input['rows']) ? $input['rows'] : 25; 
        $pageNumber=isset($input['page']) ? $input['page'] : 1; 
        $offset=$pageNumber*$pageLimit-$pageLimit;   

        //parse_str($_COOKIE['searchParams'],$searcharray);
        //print_R($searcharray);
        // $q=$this->model::query();
        // $q=$q->select('pages.*');
        // if(isset($input['identifier'])){
        //     $q=$q->where('identifier', $input['identifier']);    
        // }
        // $this->data['gridData']=$q->paginate($pageLimit);

        $this->data['gridData']=\App\Repositories\BookingRepository::getAll($request);
        
        return view('admin.'.$this->data['view'].'.index',$this->data );
    
    }

    public function form(Request $request)
    {   
        $input = $request->all();
        $this->data['tab']=isset($input['tab']) ? $input['tab'] : 'basics';
        $menu=AdminMenu::where('identifier',$request->input('identifier'))->first();        
        $this->data['pageTitle']=$menu['title'];
        $this->data['cFields']=json_decode($menu['custom_fields'],1);
        unset($menu);
        $this->data['cFields']=$this->data['cFields']['form'];        
        if(isset($this->data['cFields']['top_tools']))
            $this->data['top_tools']=$this->data['cFields']['top_tools'];   


        
        $this->data['content']=$this->model;
        if(isset($input['id']) && $input['id']>0){
            
            $this->data['content']=$this->model::find($input['id']);
        }
        else{
            $this->data['content']->visit_date=date("d-m-Y");
            if($request->session()->get('visit_date')){
                $this->data['content']->visit_date=$request->session()->get('visit_date');
            }
            
        }


        return view('admin.'.$this->data['view'].'.'.$this->data['tab'],$this->data);
    
    }

    public function save(Request $r)
    {   
          
        $input = $r->all();   
        //print_r($input);exit;
        $r->session()->put('visit_date', date("d-m-Y"));        
        if(isset($input['visit_date'])){
            
            $r->session()->put('visit_date', $input['visit_date']);
            $input['visit_date']=implode("-",(array_reverse(explode("-",$input['visit_date']))));
            
        } 
        if(isset($input['dob'])){
            $input['dob']=implode("-",(array_reverse(explode("-",$input['dob']))));
            
        } 

        if(isset($input['id']) && $input['id']>0){
            $page = $this->model::find($input['id']);        
            $page->update($input);
        }
        else{
            $page = $this->model::create($input);
        }



       
        return redirect()->route('admin.'.$this->data['view'].'.form',['identifier'=>$input['identifier']]);
    
    }



    

    

    public function status(Request $request )
    {
        $input = $request->all();
        $menu = $this->model::find($input['id']);
        $menu->status=$menu->status=='1' ? '0' : '1';
        $menu->save();        
        $page = $request->input('page');
        return redirect()->route('admin.'.$this->data['view'],['identifier'=>$request->input('identifier')]);
    }

    public function priority(Request $request){
        $input = $request->all();
        $property = $this->model::where('id',$input['id'])->update(['priority'=>$input['priority']]);        
       
        
        return response()->json([
            'success'=>1,
            'text'=>'Successfully updated the priority'
         ], 200);
    }

    public function delete(Request $request)
    {
        $input = $request->all();
        if(isset($input['id']) && count($input['id'])){
            $this->model->whereIn('id', $input['id'])->delete(); 
        }
                
        return redirect()->route('admin.'.$this->data['view'],['identifier'=>$request->input('identifier')]);        
    }

    public function download_address(Request $request){
        $pdf = PDF::loadView('/pdf/address', $this->data);
        return $pdf->stream('address.pdf');
    }

    public function export(Request $request){
        return Excel::download(new BookingExport, 'users.xlsx');
    }

    public function report(Request $request){
        $input=$request->all();       
        $menu=AdminMenu::where('identifier',$request->input('identifier'))->first();        
        $this->data['pageTitle']=$menu['title'];
        $this->data['cFields']=json_decode($menu['custom_fields'],1);
        unset($menu);
        $this->data['cFields']=$this->data['cFields']['grid'];        
        if(isset($this->data['cFields']['top_tools']))
            $this->data['top_tools']=$this->data['cFields']['top_tools']; 

        
        $pageLimit=isset($input['rows']) ? $input['rows'] : 25; 
        $pageNumber=isset($input['page']) ? $input['page'] : 1; 
        $offset=$pageNumber*$pageLimit-$pageLimit;   

        $this->data['gridData']=\App\Repositories\BookingRepository::getAll($request);
        
        if(isset($input['export'])){   
            if($input['export']=='excel') {
                return Excel::download(new BookingExport($this->data['gridData']), 'bookings.xlsx');
            }  
               
            if($input['export']=='address') {                
                $pdf = PDF::loadView('/pdf/address', $this->data);
                return $pdf->download('address.pdf');
            }            
        }

        

        return view('admin.'.$this->data['view'].'.report',$this->data );
    }


    public function view(Request $request, $id)
    {   
        $input = $request->all();
        $this->data['tab']=isset($input['tab']) ? $input['tab'] : 'basics';
        $menu=AdminMenu::where('identifier',$request->input('identifier'))->first();        
        $this->data['pageTitle']=$menu['title'];
        $this->data['cFields']=json_decode($menu['custom_fields'],1);
        unset($menu);
        $this->data['cFields']=$this->data['cFields']['form'];        
        if(isset($this->data['cFields']['top_tools']))
            $this->data['top_tools']=$this->data['cFields']['top_tools'];   


        
        $this->data['content']=$this->model;
        if(isset($id) && $id>0){
            
            $this->data['content']=\App\Repositories\BookingRepository::getRow($id);
        }


        return view('admin.'.$this->data['view'].'.view',$this->data);
    
    }





	
}
