<?php

namespace App\Http\Controllers\admin;


use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Mail;
use Validator;
use Illuminate\Support\Facades\Auth;

use App\Models\Gallery;
use App\Models\Master;


class GalleryController extends AdminBaseController
{

    public function __construct()
    {
        parent::__construct();      
        //$this->middleware('auth:admin');
        $this->view="gallery";
        $this->data['route']="gallery";
        
    }

    public function index(Request $r)
    {   
        $input = $r->all();
        $user=auth()->guard('admin')->user();
        $this->getUserActivity($input['identifier'], $user->role_id);

        $pageLimit=isset($input['rows']) ? $input['rows'] : 25; 
        $pageNumber=isset($input['page']) ? $input['page'] : 1; 
        $offset=$pageNumber*$pageLimit-$pageLimit;  

        
        $this->data['gridData']=Gallery::where('identifier', $input['identifier'])
                                        ->whereNull('deleted_by')
                                        ->orderBy('priority')
                                        ->paginate($pageLimit);  
        return view('admin.gallery.index',$this->data);
    
    }

    public function form(Request $r)
    {   
          
        $input = $r->all();
        $user=auth()->guard('admin')->user();
        $this->getUserActivity($input['identifier'], $user->role_id);

        
        $this->data['content']='';
        if(isset($input['id']) && $input['id']>0){
            $this->data['content']=Gallery::find($input['id']);
        }
        $this->data['category']=Master::where('status','1')->where('identifier', 'gallery-category')->get();
       
        return view('admin.gallery.form',$this->data);
    
    }

    public function save(Request $r)
    {   
          
        $input = $r->all();

        
        if(isset($input['id']) && $input['id']>0){
            $page = Gallery::find($input['id']);        
            $page->update($input);
        }
        else{
            $page = Gallery::create($input);
        }

        return redirect()->route('admin.gallery.form',['identifier'=>$input['identifier']]);
    
    }



    public function delete(Request $request)
    {
        $input = $request->all();
        $user=auth()->guard('admin')->user();
        $message="";
        if(isset($input['id']) && count($input['id'])>0){
           foreach($input['id'] as $id){
                $object=Gallery::find($id);
                $object->deleted_at=date('Y-m-d H:i:s');
                $object->deleted_by=$user->id;
                $object->save();
           }    

        }
                
        return redirect()->route('admin.'.$this->view,['identifier'=>$request->input('identifier')])->with('message',$message );        
    }

  

    public function status(Request $request,$id)
    {  
        $input = $request->all(); 
        $object=Gallery::find($id);
        $status =$object['status']==1? '0' : '1';
        
        $object->status=$status;
        $object->save();

        return redirect()->route('admin.'.$this->view,['identifier'=>$request->input('identifier')]);        
    }


    public function priority(Request $request){
        $input = $request->all();
        $property = Gallery::where('id',$input['id'])->update(['priority'=>$input['priority']]);        
       
        
        return response()->json([
            'success'=>1,
            'text'=>'Successfully updated the priority'
         ], 200);
    }
  

   
    

	
}
