<?php

namespace App\Http\Controllers\admin;


use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Mail;
use Validator;
use Illuminate\Support\Facades\Auth;
use DB;

use App\Models\Widget;
use App\Models\Page;

class WidgetController extends AdminBaseController
{

    public function __construct()
    {
        parent::__construct();      
        //$this->middleware('auth:admin');
        
    }

    public function index(Request $r)
    {   
        $this->data['gridData']=Widget::get();    
        return view('admin.widget.index',$this->data);
    
    }

    public function form(Request $r)
    {   
          
        $input = $r->all();


        $this->data['content']='';
        if(isset($input['id']) && $input['id']>0){
            $this->data['content']=Widget::find($input['id']);
            $this->data['cFields']=json_decode($this->data['content']['custom_fields'],1);              

        }
        $this->data['pages']=Page::where('status','1')->get();
       
        return view('admin.widget.form',$this->data);
    
    }

    public function save(Request $r)
    {   
          
        $input = $r->all();

        if(isset($input['section_table'])){
            $query=DB::table($input['section_table']);
            if(isset($input['identifier'])){
                $query=$query->where('identifier',$input['identifier']);
            }            
            $query->where('is_featured','1')->update(['is_featured'=>'0']);

            $featured_ids=explode("|", $input['featured_ids']);
            if(isset($featured_ids) && count($featured_ids)){                
                foreach($featured_ids as $id){
                    DB::table($input['section_table'])->where('id',$id)->update(['is_featured' => '1']);
                }
            }
        }
        
        if(isset($input['id']) && $input['id']>0){
            $page = Widget::find($input['id']);        
            $page->update($input);
        }
        else{
            $page = Widget::create($input);
        }

        return redirect()->route('admin.widget',['widget_identifier'=>$input['widget_identifier']]);
    
    }

  

   
    

	
}
